// MapCell.java
// Started on March 29th, 2002
// Copyright (c) Virtu Halttunen

//import TheGame.*;

public class MapCell
{
    private int [] floors;
    private int wall;
    private byte weight;
    private byte light;
    private boolean hasObjects;

    public MapCell()
    {
        floors = new int[1];
        floors[0]=-1;
        wall = -1;
        weight = 0;
        light = 0;
    }
    
    public void setFloor( int floor )
    {
        floors[ floors.length-1 ] = floor;
    }

    public void setFloor( int index, int floor )
    {
        floors[ index ] = floor;
    }

    public void setFloor( int [] floors )
    {
        this.floors = floors;
    }

    public void addFloor( int floor )
    {
	if( floors[ 0 ] < 0 )
	{
	    floors[ 0 ] = floor; // No need to grow, we can replace empty cells
	    return;
	}
        int [] newFloors = new int[ floors.length+1 ];
        // Copy the floors after the entry to new array
        for( int i=0; i<floors.length;i++ )
        {
            newFloors[ i ] = floors[i];
        }
        newFloors[ floors.length ] = floor;
        floors = newFloors;
    }

    public void insertFloor( int after, int floor )
    {
        // First, we need to grow the array
        int [] newFloors = new int[ floors.length+1 ];
        // Copy the floors after the entry to new array
        for( int i=after+1; i<floors.length;i++ )
        {
            newFloors[ i+1 ] = floors[i];
        }
        // Set the new floor piece
        newFloors[ after+1 ] = floor;
        // Then copy the previous pieces
        for( int i=0; i <= after; i++ )
        {
            newFloors[i]=floors[i];
        }
        // Finally, switch the arrays
        floors=newFloors;
            
    }

    public void setDoor( boolean door )
    {
        if( door )
        {
            wall = -2;
        }
        else
        {
            wall = 0;
        }
    }

    public boolean hasDoor()
    {
        if( wall < -1 )
        {
            return true;
        }
        return false;
    }
    
    public void setObjects( boolean hasObjects )
    {
        this.hasObjects = hasObjects;
    }

    public boolean hasObjects()
    {
        return hasObjects;
    }

    public int getFloorSize()
    {
        return floors.length;
    }

    public int getFloor( int index )
    {
        return floors[ index ];
    }

    public int getFloor()
    {
        return floors[ floors.length-1 ];
    }

    public void setWall( int wall )
    {
        this.wall = wall;
    }

    public int getWall()
    {
        return wall;
    }

    public void setLight( byte light )
    {
        this.light = light;
    }

    public byte getLight()
    {
        return light;
    }

}