// BobSprite.java
// Started on February 28th 5th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.ImageIcon;

public class BobSprite extends CharacterSprite
{

    private static Image [][] images = null;
    private int deadDir = -1;
    
    public BobSprite()
    {
        if( images == null )
        {
            images = new Image[6][8];
            Vector temp = new Vector();
            ResourceManager.cropImage( "Bob.png", temp, 96 );
	    // Walk sprites
            images[0][ Map.NORTH ] = (Image)temp.elementAt( 0 );
            images[0][ Map.NORTH_EAST ] = (Image)temp.elementAt( 1 );
            images[0][ Map.EAST ] = (Image)temp.elementAt( 2 );
            images[0][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 3 );
            images[0][ Map.SOUTH ] = (Image)temp.elementAt( 4 );
            images[0][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 5 );
            images[0][ Map.WEST ] = (Image)temp.elementAt( 6 );
            images[0][ Map.NORTH_WEST ] = (Image)temp.elementAt( 7 );
            images[1][ Map.NORTH ] = (Image)temp.elementAt( 0+8 );
            images[1][ Map.NORTH_EAST ] = (Image)temp.elementAt( 1+8 );
            images[1][ Map.EAST ] = (Image)temp.elementAt( 2+8 );
            images[1][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 3+8 );
            images[1][ Map.SOUTH ] = (Image)temp.elementAt( 4+8 );
            images[1][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 5+8 );
            images[1][ Map.WEST ] = (Image)temp.elementAt( 6+8 );
            images[1][ Map.NORTH_WEST ] = (Image)temp.elementAt( 7+8 );
	    images[2][ Map.NORTH ] = (Image)temp.elementAt( 0+16 );
            images[2][ Map.NORTH_EAST ] = (Image)temp.elementAt( 1+16 );
            images[2][ Map.EAST ] = (Image)temp.elementAt( 2+16 );
            images[2][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 3+16 );
            images[2][ Map.SOUTH ] = (Image)temp.elementAt( 4+16 );
            images[2][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 5+16 );
            images[2][ Map.WEST ] = (Image)temp.elementAt( 6+16 );
            images[2][ Map.NORTH_WEST ] = (Image)temp.elementAt( 7+16 );
	    // Melee sprites
	    images[3][ Map.NORTH ] = (Image)temp.elementAt( 0+24 );
            images[3][ Map.NORTH_EAST ] = (Image)temp.elementAt( 1+24 );
            images[3][ Map.EAST ] = (Image)temp.elementAt( 2+24 );
            images[3][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 3+24 );
            images[3][ Map.SOUTH ] = (Image)temp.elementAt( 4+24 );
            images[3][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 5+24 );
            images[3][ Map.WEST ] = (Image)temp.elementAt( 6+24 );
            images[3][ Map.NORTH_WEST ] = (Image)temp.elementAt( 7+24 );
	    // Wound sprites
	    images[4][ Map.NORTH ] = (Image)temp.elementAt( 0+32 );
            images[4][ Map.NORTH_EAST ] = (Image)temp.elementAt( 1+32 );
            images[4][ Map.EAST ] = (Image)temp.elementAt( 2+32 );
            images[4][ Map.SOUTH_EAST ] = (Image)temp.elementAt( 3+32 );
            images[4][ Map.SOUTH ] = (Image)temp.elementAt( 4+32 );
            images[4][ Map.SOUTH_WEST ] = (Image)temp.elementAt( 5+32 );
            images[4][ Map.WEST ] = (Image)temp.elementAt( 6+32 );
            images[4][ Map.NORTH_WEST ] = (Image)temp.elementAt( 7+32 );
	    // Dead sprites
	    images[5][ 0 ] = (Image)temp.elementAt( 0+40 );
            images[5][ 1 ] = (Image)temp.elementAt( 1+40 );
            images[5][ 2 ] = (Image)temp.elementAt( 2+40 );
            images[5][ 3 ] = (Image)temp.elementAt( 3+40 );
            	    
        }
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 96, 96 );
        direction = Map.NORTH;
    }

    public Image getSprite( GameAction action )
    {
        if( action instanceof DeadAction )
        {
	    if( deadDir < 0 )
	    {
		deadDir = (int)(Math.random()*4);
	    }
	    return images[ 5 ][ deadDir ];
        }
	if( action instanceof MoveAction )
	{
	    int theFrame = 0;
	    switch( frame )
	    {
		case 1:
		    theFrame = 1;
		    break;
		case 3:
		    theFrame = 2;
		    break;
	    }
	    return images[ theFrame ][ direction ]; 
	}
	if( action instanceof MeleeAction )
	{
	    int theFrame = 3;
	    switch( frame )
	    {
		case 0:
		case 4:
		    theFrame = 0;
		    break;
	    }
	    return images[ theFrame ][ direction ];
	}
	if( action instanceof WoundAction )
	{
	    return images[ 4 ][ direction ];
	}
        return images[ 0 ][ direction ]; 
    }

    public int getNumberOfWalkFrames()
    {
	return 5;
    }
	
    public int getNumberOfMeleeAttackFrames()
    {
	return 5;
    }
    
    public Image getSprite()
    {
	if( deadDir < 0 )
	{
	    deadDir = (int)(Math.random()*4);
	}
	return images[ 5 ][ deadDir ];
    }

    public Rectangle getBounds()
    {
        return bounds;
    }

    public Point getLocation()
    {
        return location;
    }    
    
    public Rectangle getVisualBounds()
    {
	return new Rectangle( location.x+24, location.y+24, 48, 48 );
    }
    
    public void setLocation( Point location)
    {
        this.location.x = location.x-24;
        this.location.y = location.y-24;
        bounds.x = location.x;
        bounds.y = location.y;
    }
    
    public void setLocation( int x, int y )
    {
        location.x = x-24;
        location.y = y-24;
        bounds.x = x-24;
        bounds.y = y-24;
    }
    
    
}