// CentipedoidSprite.java
// Started on August 24th, 2005
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;

public class CentipedoidSprite extends CharacterSprite
{
    private static Image [][] images = null;
    
    private int typeIndex = Centipedoid.HEAD;
    
    public CentipedoidSprite()
    {
	if( images == null )
	{
	    images = new Image[3][8];
	    Vector temp = new Vector();
	    // Load all the images and hope they end up in the correct slots
	    ResourceManager.cropImage( "Centipedoid.png", temp, 240 );
	    int index = 0;
	    for( int row=0; row < 3; row++ )
	    {
		for( int dir=0; dir < 8; dir++ )
		{
		    images[ row ][ dir ] = (Image)temp.elementAt( index++ );
		    //System.out.println( "Row: " + row + " Dir: " + dir + " Index: " + (index-1) );
		}
	    }
	}
 	location = new Point( 0, 0 );
	bounds = new Rectangle( 0, 0, 240, 240 );
	direction = Map.NORTH;
    }
    
    public void setCharacter( Character character )
    {
	super.setCharacter( character );
	if( character instanceof Centipedoid )
	{
	    typeIndex = ((Centipedoid)character).getSegmentType();
	}
    }
    
    public Image getSprite( GameAction action )
    {
	return images[ typeIndex ][ direction ];
    }

    public int getNumberOfWalkFrames()
    {
	return 10;
    }
    
    public int getNumberOfMeleeAttackFrames()
    {
	return 10;
    }

    public int getNumberOfRangedAttackFrames()
    {
	return 1;
    }
    
    public Rectangle getVisualBounds()
    {
	return new Rectangle( location.x+48, location.y+72, 96, 96 );
    }
    
    public void setLocation( Point location)
    {
        this.location.x = location.x-72;
        this.location.y = location.y-96;
        bounds.x = location.x;
        bounds.y = location.y;
    }
    
    public void setLocation( int x, int y )
    {
        location.x = x-72;
        location.y = y-96;
        bounds.x = x-72;
        bounds.y = y-96;	
    }
    
}