// ComputerSprite.java
// Started on March 25th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.ImageIcon;

public class ComputerSprite extends Sprite
{

    private static Image [] images = null;
    private static Image brokenImage = null;
    private int direction = Map.NORTH;
    private boolean destroyed = false;

    public ComputerSprite()
    {
        if( images == null )
        {

            images = new Image[4];
            Vector temp = new Vector();
            ResourceManager.cropImage( "computer.png", temp, 48 );
            images[0] = (Image)temp.elementAt( 0 );
            images[1] = (Image)temp.elementAt( 1 );
            images[2] = (Image)temp.elementAt( 3 );
            images[3] = (Image)temp.elementAt( 2 );
            brokenImage = ResourceManager.loadImage( "brokenComputer.png" );
        }
        location = new Point( -1, -1 );
        bounds = new Rectangle( 0, 0, 48, 48 );
    }

    public void setDirection( int direction )
    {
        this.direction = direction;
    }

    public void setDestroyed()
    {
        destroyed = true;
    }

    public Image getSprite( GameAction action )
    {
        return getSprite();
    }

    public Image getSprite()
    {
        if( destroyed )
            return brokenImage;
        return images[ direction/2 ];
    }
}