// DisarmMinesObjective.java
// Started on July 7th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;
import java.io.*;

public class DisarmMinesObjective extends Objective
{
    protected Game activeGame;
    private boolean secured = false;

    public void setGame( Game game )
    {
        activeGame = game;
        Mine mine;
        Point mStart;
        int mines = (int)(Math.random()*29)+1;
        for( int i=0; i < mines; i++ )
        {
            mine = new Mine();
            mine.setGame( activeGame );
            mStart = activeGame.getRandomPointForMonster();
            mine.setLocation( mStart );
            mine.setSetByPlayer( false );
            mine.setArmed( true );
            activeGame.addMonster( mine );
        }
        MineBehaviorObjective mineBehavior = new MineBehaviorObjective();
        activeGame.addObjective( mineBehavior );
    }

    public int getNumberOfSprites()
    {
        return 0;
    }

    public Sprite getSprite( int x, int y )
    {
        return null;
    }

    public String [] getPropertyNames()
    {
        return null;
    }

    public String getProperty( String key )
    {
        return null;
    }

    public void setProperty( String key, String value ) throws IllegalArgumentException
    {}

    public void setLocation( Point point )
    {}

    public void setLocation( int x, int y )
    {
        setLocation( new Point( x, y ) );
    }

    public boolean showCompletionMessageImmediately()
    {
        return false;
    }

    public boolean isCompleted()
    {
        secured = true;
        for( int i = 0; i < activeGame.getMonsters().size(); i++ )
        {
            Character monster = activeGame.getMonster( i );
            if( monster instanceof Mine )
            {
                if( ((Mine)monster).isArmed() && monster.isAlive() )
                {
                    secured = false;
                }
            }
        }
        return secured;
    }

    public boolean isLocatedIn( Point point )
    {
        return false;
    }

    public boolean isLocatedIn( int x, int y )
    {
        return false;
    }

    public boolean isDestructible()
    {
        return false;
    }

    public boolean isShownOnMap()
    {
        return false;
    }

    public boolean handleDamage( Point point, int damage )
    {
        return false;
    }

    public boolean handleAction( GameAction action )
    {
        return false;
    }

}