// EggSprite.java
// Started on June 30th, 2001
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.ImageIcon;

public class EggSprite extends CharacterSprite
{
    
    private static Image [] images = null;

    public EggSprite()
    {
	if( images == null )
	{
	    images = new Image[2];
	    Vector temp = new Vector();
	    ResourceManager.cropImage( "Egg.png", temp, 48 );

	    images[0] = (Image)temp.elementAt( 0 );
	    images[1] = (Image)temp.elementAt( 2 );
	}
	location = new Point( 0, 0 );
	bounds = new Rectangle( 0, 0, 48, 48 );
	direction = Map.NORTH;
    }
    
    public Image getSprite( GameAction action )
    {
	if( action instanceof DeadAction )
	{
	    return images[ 1 ];
	}
	return images[ 0 ];
    }
    
    public Image getSprite()
    {
	return images[1];
    }

    public int getNumberOfWalkFrames()
    {
	return 1;
    }
}