// MapObjectCell.java
// Started on March 29th, 2002 as MapObject
// Copyright (c) Virtu Halttunen

package TheGame;

public class MapObjectCell
{
    private int x;
    private int y;
    private int type;
    private int destroyedType=-1;
    private int hitPoints;
    private boolean destroyed = false;
    private boolean blocksMovement;
    private boolean blocksSight;

    public MapObjectCell( int x, int y, int type, int hitPoints, boolean blocksMovement, boolean blocksSight )
    {
        this.x = x;
        this.y = y;
        this.type = type;
        this.hitPoints = hitPoints;
        this.blocksMovement = blocksMovement;
        this.blocksSight = blocksSight;
	if( hitPoints <= 0 )
	{
	    destroyedType = type;
	    destroyed = true;
	}
	else
	{
	    destroyedType = type+1;
	}
    }

    public int getX()
    {
        return x;
    }

    public int getY()
    {
        return y;
    }

    public boolean isLocatedIn( int x, int y )
    {
        if( this.x==x && this.y==y )
        {
            return true;
        }
        return false;
    }

    public int getType()
    {
        return type;
    }
    
    public int getDestroyedType()
    {
	return destroyedType;
    }

    public void setDestroyedType( int destroyedType )
    {
	this.destroyedType = destroyedType;
    }
    
    public int getHitPoints()
    {
        return hitPoints;
    }
    
    public boolean isDestroyed()
    {
	return destroyed;
    }
    
    public void setDestroyed( boolean destroyed )
    {
	this.destroyed = destroyed;
    }

    public boolean isBlockingMovement()
    {
        if( destroyed )
            return false;
        return blocksMovement;
    }

    public boolean isBlockingSight()
    {
        if( destroyed )
            return false;
        return blocksSight;
    }
    

    // returns true if destroyed
    public boolean applyDamage( int damage )
    {
        if( damage > hitPoints )
        {
            hitPoints-=(damage-hitPoints);
        }
        if( hitPoints <= 0 )
            return true;
        return false;
    }
    
    public void setPosition( int x, int y )
    {
	this.x = x;
	this.y = y;
    }

}