// MarineStatisticsPanel.java
// Started on February 13th, 2002
// Copyright (c) Virtu Halttunen

package TheGame;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

public class MarineInfoDialog extends JDialog implements ActionListener
{
    private MarineInfoPanel marinePanel;
    private JButton ok;

    public MarineInfoDialog( Frame owner )
    {
        super( owner );
        Box full = Box.createVerticalBox();
        Box top = Box.createHorizontalBox();
        marinePanel = new MarineInfoPanel();
        top.add( marinePanel );
        JPanel bottom = new JPanel();
        ok = new JButton( "Ok" );
        ok.setDefaultCapable( true );
        ok.addActionListener( this );
        bottom.add( ok );
        full.add( top );
        full.add( bottom );
        getContentPane().add( full );
        setResizable( true );
        getRootPane().setDefaultButton( ok );
        //ok.requestFocus();
        pack();
    }

    public void actionPerformed( ActionEvent e )
    {
        if( e.getSource() == ok )
        {
            setVisible( false );
        }
    }

    public void setMarine( Marine marine )
    {
        marinePanel.setMarine( marine );
        setTitle( Marine.ranks[ marine.getRank() ] + " " + marine.getName() );
        repaint();
    }
}