// Mine.java
// Started on July 6th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;
import java.util.Vector;

public class Mine extends Monster implements Armed
{
    public static final int ROAMING = 0;
    public static final int SEEKING = 1;
    public static final int ATTACKING = 2;
    public static final int WAITING = 3;

    private Character target = null;
    private boolean hasMoreActions = false;
    private int state = ROAMING;
    private Weapon weapon;
    private boolean blasted = false;
    private boolean discovered = false;
    private boolean armed = false;
    private boolean setByPlayer = false;

    public Mine()
    {
        location = new Point( 0, 0 );
        direction = Map.NORTH;
        alive = true;
        lastAction = new MoveAction( this, location, location );
        maximumActionPoints = 1;
        currentActionPoints = 1;
        maximumHitPoints = 5;
        currentHitPoints = 5;
        weapon = new AssaultRifle();
        weapon.setFiringMode( AssaultRifle.GRENADE );
    }

    public void setLocation( Point point )
    {
        location = new Point( point );
        lastAction = new MoveAction( this, location, location );
    }
    
    public void setSpottedPlayer( Character character, boolean canSee )
    {
    }

    public void setState( int state )
    {
        this.state = state;
    }

    public void setDiscovered( boolean discovered )
    {
        this.discovered = discovered;
    }

    public boolean isDiscovered()
    {
        return discovered;
    }

    public void setSetByPlayer( boolean setByPlayer )
    {
        this.setByPlayer = setByPlayer;
    }
    
    public boolean isSetByPlayer()
    {
        return setByPlayer;
    }
    
    public Weapon getWeapon()
    {
        return weapon;
    }

    public void setWeapon( Weapon weapon )
    {}

    public GameAction playAction()
    {
        return lastAction;
    }
        
    public GameAction getLastAction()
    {
        return lastAction;
    }

    public void resetActionsPoints()
    {
        currentActionPoints = maximumActionPoints;
    }

    public int getWeaponSkill()
    {
        return 10;
    }

    public boolean hasMoreActions()
    {
        return false;
    }

    public boolean isAlive()
    {
        return alive;
    }

    public boolean isFoe( Character character )
    {
        return false;
    }
        
    public boolean isShownOnMap()
    {
        return false;
    }

    public boolean isArmed()
    {
        return armed;
    }

    public void setArmed( boolean armed )
    {
        this.armed = armed;
    }

    public void setGoingBoom()
    {
        currentActionPoints = 10;
        currentHitPoints = 0;
        blasted = true;
        discovered = true;
        activeGame.handleRangedAttack( this, location );
	activeGame.addCorpse( this );
    }
    
    public void addKill()
    {}
    
    public void registerHit()
    {}    
    
    public boolean applyDamage( int damage )
    {
        if( damage >= currentHitPoints )
        {
            alive = false;
 	    if( !blasted )
            {
		blasted = true;
		currentActionPoints = 10;
                activeGame.handleRangedAttack( this, location );
            }
	    lastAction = new DeadAction( this, new Point( location ) );
            maximumActionPoints = 0;
            currentActionPoints = 0;
        }
        return alive;
    }

    public int getMeleeAbility()
    {
	return -1;
    }
    
    public int getSize()
    {
        return 10;
    }
}