// Oid.java (aka "gryb")
// Started on June 20th, 2001
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;

public class Oid extends Monster
{
    public Oid()
    {
	location = new Point( 0, 0 );
	direction = Map.NORTH;
	alive = true;
	lastAction = new MoveAction( this, location, location );
	maximumActionPoints = 1;
	currentActionPoints = 1;
	maximumHitPoints = 3;
	currentHitPoints = 3;
    }
    
    public GameAction playAction()
    {
	int x; 
	int y;

	Point cell;
	if( alive )
	{
	    if( currentActionPoints > 0 )
	    {
		for( int i=0; i < 8; i++ )
		{
		    for( int j=0; j < activeGame.getPlayerCharacters().size(); j++ )
		    {
			if( activeGame.getPlayerCharacter(j).isAlive() )
			{
			    cell = activeGame.getPlayerCharacter(j).getLocation();
			    if( cell.equals( activeGame.getMap().getNeighbor( location, i ) ) )
			    {
				direction = i;
				//System.out.println( "Oid attacking " + cell.toString() );
				lastAction = new MeleeAction( this, activeGame.getPlayerCharacter(j) );
				return lastAction;
			    }
			}
		    }
		}
		do
		{
		    x = location.x;
		    y = location.y;
		    x = x + (int)(Math.random()*3)-1;
		    y = y + (int)(Math.random()*3)-1;
		} while( !activeGame.getMap().isPassable( x, y ) );
		lastAction = new MoveAction( this, new Point( location ), new Point( x, y ) );
		/*
		direction = Map.getDirection( location, new Point( x, y ), direction );
		location.x = x;
		location.y = y;
		currentActionPoints--;*/
	    }
	    else
	    {
		lastAction = new WaitAction( this, new Point( location ) );
	    }
	}
	return lastAction;
    }
        
    public boolean applyDamage( int damage )
    {
	currentHitPoints = currentHitPoints-damage;
	lastAction = new MoveAction( this, location, location );
	if( currentHitPoints <= 0 )
	{
	    alive = false;
	    lastAction = new DeadAction( this, new Point( location ) );
	    //System.out.println( "Oid killed!" );
	}
	return alive;
    }
    
    public int getMeleeAbility()
    {
	return 5;
    }
    
    public boolean isAlive()
    {
	return alive;
    }

}