// OidSprite.java
// Started on June 20th, 2001
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;
import javax.swing.*;

public class OidSprite extends CharacterSprite
{
   
    private static Image [] images = null;
    
    public OidSprite()
    {
	if( images == null )
	{
	    images = new Image[9];
	    Vector temp = new Vector();
	    ResourceManager.cropImage( "Oid.png", temp, 48 );
	    images[ Map.NORTH ] = (Image)temp.elementAt( 7 );
	    images[ Map.NORTH_WEST ] = (Image)temp.elementAt( 8 );
	    images[ Map.NORTH_EAST ] = (Image)temp.elementAt( 6 );
	    images[ Map.WEST ] = (Image)temp.elementAt( 5 );
	    images[ Map.EAST ] = (Image)temp.elementAt( 3 );
	    images[ Map.SOUTH_WEST ] = (Image)temp.elementAt( 2 );
	    images[ Map.SOUTH ] = (Image)temp.elementAt( 1 );
	    images[ Map.SOUTH_EAST ] = (Image)temp.elementAt( 0 );
	    images[ 8 ] = (Image)temp.elementAt( 4 );
 	}
	location = new Point( 0, 0 );
	bounds = new Rectangle( 0, 0, 48, 48 );
	direction = Map.NORTH;
    }
    
    public Image getSprite( GameAction action )
    {
	if( action instanceof DeadAction )
	{
	    return images[ 8 ];
	}
	if( action instanceof MeleeAction )
	{
	    return images[ (direction+4)%8 ];
	}
	return images[ direction ];
    }
    
    public Image getSprite()
    {
	return images[8];
    }

}