// PushObjectAction.java
// Started on August 7th, 2005
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;

public class PushObjectAction implements GameAction
{
    private Point startPoint;
    private Point endPoint;
    private Character actor;
    private int cost = 1;
    private MapObject object;
    private boolean bounce = false;
    
    public PushObjectAction( Character actor, MapObject object, Point startPoint, Point endPoint )
    {
	//System.out.println( "New move action:  Start: " + startPoint.toString() + " End: " + endPoint.toString() );
	this.actor = actor;
	this.startPoint = new Point( startPoint );
	this.endPoint = new Point( endPoint );
	this.object = object;
    }
    
    public Character getActor()
    {
	return actor;
    }
    
    public Point getStartPoint()
    {
	return new Point( startPoint );
    }
    
    public Point getEndPoint()
    {
	return new Point( endPoint );
    }
    
    public void setEndPoint( Point point )
    {
	endPoint = new Point( point );
    }
    
    public int getCost()
    {
	return cost;
    }
    
    public void setCost( int cost )
    {
	this.cost = cost;
    }
    
    public MapObject getObject()
    {
	return object;
    }
    
    public void setBounce( boolean bounce )
    {
	this.bounce = bounce;
    }
    
    public boolean isBounce()
    {
	return bounce;
    }
}