// SentryGunObjective.java
// Started on August 11th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;
import java.io.*;
import java.util.Vector;

public class SentryGunObjective extends Objective
{
    protected Game activeGame;
    
    public SentryGunObjective()
    {
    }

    public void setGame( Game activeGame )
    {
        this.activeGame = activeGame;        
    }

    public int getNumberOfSprites()
    {
        return 0;
    }    
    
    public Sprite getSprite( int x, int y)
    {
        return null;
    }

    public String [] getPropertyNames()
    {
        return null;
    }

    public String getProperty( String key )
    {
        return null;
    }

    public void setProperty( String key, String value ) throws IllegalArgumentException
    {
    }    
    
    public boolean isCompleted()
    {
        return true;
    }

    public int getSize()
    {
        return 0;
    }

    public boolean isLocatedIn( Point point )
    {
        int monsters = activeGame.getMonsters().size();
        Monster monster;
        for( int i=0; i < monsters; i++ )
        {
            monster = activeGame.getMonster( i );
            if( monster instanceof SentryGun )
            {
                if( monster.getLocation().equals( point ) && monster.isAlive() )
                {
                    return true;
                }
            }
        }
        return false;
    }

    public boolean isLocatedIn( int x, int y )
    {
        return isLocatedIn( new Point( x, y ) );
    }

    public boolean isDestructible()
    {
        return false;
    }

    public boolean isShownOnMap()
    {
        return false;
    }

    public boolean handleDamage( Point point, int damage )
    {
        return false;
    }

    public boolean handleAction( GameAction action )
    {
        boolean handled = false;
        Character character = action.getActor();
        // Check move actions
        if( action instanceof MoveAction && activeGame.isPlayerCharacter( character ) )
        {
            Point point = ((MoveAction)action).getEndPoint();
            Point start = ((MoveAction)action).getStartPoint();

            SentryGun gun = null;
            // Does the move end on a Sentry gun?
            int monsters = activeGame.getMonsters().size();
            Monster monster;
            for( int i=0; i < monsters; i++ )
            {
                monster = activeGame.getMonster( i );
                if( monster instanceof SentryGun )
                {
                    if( monster.getLocation().equals( point ) && monster.isAlive() )
                    {
                        gun = (SentryGun)monster;
                    }
                }
            }
            if( gun != null )
            {
                int direction = Map.getDirection( start, point, 0 );
                if( activeGame.getMap().isPassable( point, direction ) )
                {
                    activeGame.moveCharacter( gun, direction );
                    //gun.setLocation( activeGame.getMap().getNeighbor( point, direction ) );
                }
                else
                {
                    direction = Map.getDirection( point, start, 0 );
                    activeGame.moveCharacter( gun, direction );
                    //gun.setLocation( start );
                }
                //activeGame.setMapChanged();
                handled = true;
            }
        }
        return handled;
    }
}