// SentryGunSprite.java
// Started on August 11th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import java.util.Vector;

public class SentryGunSprite extends CharacterSprite
{

    private static Image [][] images = null;
    private static Image corpse = null;

    public SentryGunSprite()
    {
        if( images == null )
        {
            images = new Image[8][2];
            Vector temp = new Vector();
            ResourceManager.cropImage( "SentryGun.png", temp, 96 );
            // Waiting frames
            images[ Map.NORTH ][0] = (Image)temp.elementAt( 1 );
            images[ Map.NORTH_WEST ][0] = (Image)temp.elementAt( 0 );
            images[ Map.NORTH_EAST ][0] = (Image)temp.elementAt( 2 );
            images[ Map.WEST ][0] = (Image)temp.elementAt( 3 );
            images[ Map.EAST ][0] = (Image)temp.elementAt( 5 );
            images[ Map.SOUTH_WEST ][0] = (Image)temp.elementAt( 6 );
            images[ Map.SOUTH ][0] = (Image)temp.elementAt( 7 );
            images[ Map.SOUTH_EAST ][0] = (Image)temp.elementAt( 8 );
            // Shooting frames
            images[ Map.NORTH ][1] = (Image)temp.elementAt( 10 );
            images[ Map.NORTH_WEST ][1] = (Image)temp.elementAt( 9 );
            images[ Map.NORTH_EAST ][1] = (Image)temp.elementAt( 11 );
            images[ Map.WEST ][1] = (Image)temp.elementAt( 12 );
            images[ Map.EAST ][1] = (Image)temp.elementAt( 14 );
            images[ Map.SOUTH_WEST ][1] = (Image)temp.elementAt( 15 );
            images[ Map.SOUTH ][1] = (Image)temp.elementAt( 16 );
            images[ Map.SOUTH_EAST ][1] = (Image)temp.elementAt( 17 );

            corpse = (Image)temp.elementAt( 4 );
        }
        location = new Point( 0, 0 );
        bounds = new Rectangle( 0, 0, 96, 96 );
        direction = Map.NORTH;
    }

    public Image getSprite( GameAction action )
    {
        if( action instanceof ShootAction )
        {
            int aFrame=frame%2;
            return images[ direction ][ aFrame ];
        }
        if( action instanceof DeadAction )
        {
            return corpse;
        }
        return images[ direction ][0];

    }

    public void setLocation( Point location)
    {
        this.location.x = location.x-24;
        this.location.y = location.y-24;
        bounds.x = location.x;
        bounds.y = location.y;
    }

    public void setLocation( int x, int y )
    {
        location.x = x-24;
        location.y = y-24;
        bounds.x = x-24;
        bounds.y = y-24;
    }

    public int getNumberOfRangedAttackFrames()
    {
        return 11;
    }
}