// Sprite.java
// Started on June 29th, 2001
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Image;

public abstract class Sprite
{
    protected Point location;
    protected Rectangle bounds;
    
    public abstract Image getSprite();
    
    public abstract Image getSprite( GameAction action );
    
    public Point getLocation()
    {
	return location;
    }
    
    public void setLocation( Point location )
    {
	this.location = location;
	bounds.x = location.x;
	bounds.y = location.y;
    }
    
    public void setLocation( int x, int y )
    {
	location.x = x;
	location.y = y;
	bounds.x = x;
	bounds.y = y;
    }

    public void setFrame( int frame )
    {
    }
    
    public boolean isVisible()
    {
        return true;
    }

    public boolean isAnimated()
    {
        return false;
    }
    
    public void setVisible( boolean visible )
    {}

    public void setBounds( Rectangle bounds )
    {
        this.bounds = new Rectangle( bounds );
    }
             
    public Rectangle getBounds()
    {
	return bounds;
    }
    
    public Rectangle getVisualBounds()
    {
	return getBounds();
    }

    public int getXOffset()
    {
        return 0;
    }

    public int getYOffset()
    {
        return 0;
    }

}