// SubmachineGun.java
// Started on September 7th, 2003
// Copyright (c) Virtu Halttunen

package TheGame;

import java.awt.*;
import javax.swing.ImageIcon;

public class SubmachineGun extends Weapon
{
    private String [] firingModes = { "Normal" };
    private static Image icon = null;

    public static final int COST = 2;


    public SubmachineGun()
    {
        if( icon == null )
        {
            icon = ResourceManager.loadImage( "WeaponGraphics/SubmachineGunIcon.png" );
        }
    }

    public int getDamage()
    {
        return (int)(Math.random()*3)+1;
    }

    public int getDamage( boolean critical )
    {
        if( critical )
            return 3;
        return getDamage();
    }

    public int getDamage( int range, boolean critical )
    {
        int damage;
        if( critical )
            damage = 3;
        else
            damage = getDamage();
        if( range > 10 )
        {
            damage -= (range-8)/4;
        }
        if( damage <= 0 )
            damage = 1;
        return damage;
    }

    public int getActionsToFire()
    {
        return 1;
    }

    public int getCost()
    {
        return COST;
    }


    public boolean hasAreaEffect()
    {
        return false;
    }

    public String getName()
    {
        return "Submachine gun";
    }

    public Point [] getArea( Game theGame, Point fireFrom, Point fireTo )
    {
        Point [] area = new Point[1];
        area[0]=fireTo;
        return area;
    }

    public String [] getFiringModeNames()
    {
        return firingModes;
    }

    public int getNumberOfFiringModes()
    {
        return 1;
    }

    public int getFiringMode()
    {
        return 0;
    }

    public void setFiringMode( int mode )
    {
    }

    public int getRequiredAttribute()
    {
        return Marine.HANDGUN;
    }

    public Image getIcon()
    {
        return icon;
    }
}